#ifndef X_HUFF_HPP
#define X_HUFF_HPP

#include <stdio.h>
#include "x_types.h"

#define	MAX_CHAR	256
#define TWICE_MAX	(2 * MAX_CHAR)

class Huff {
  short root, __far *left, __far *right;
  ushort __far *code;
  byte __far *code_len;
  ushort __far *freq;
  short build_tree();
  void gen_codes(short node, ushort code, byte code_len);
public:
  void Encode_Symbol(int c, ushort *code, int *code_len);
  int Decode_Symbol(byte *mask, byte **data);
  Huff(FILE *f);
  ~Huff();
};

#endif
